/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.ParamCanjePunto;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ParamCanjePuntoService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderSendaAmigoParamCanjePunto;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Rafius //ParamCanjePunto
 */
@Controller("busquedaParamCanjePuntoController")
@Scope("prototype")
public class BusquedaParamCanjePuntoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ParamCanjePunto> plwParamCanjePunto;
    @Autowired
    private ParamCanjePuntoService paramCanjePuntoService;
    @Autowired
    private ParadaService paradaService;
    private List<ParamCanjePunto> lsParamCanjePunto;
    private Combobox cmbOrigem;
    private Combobox cmbDestino;
    private Datebox fecInicio;
    private Datebox fecFinal;
    private MyListbox paramCanjePuntoList;
    private Paging pagingParamCanjePunto;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        paramCanjePuntoList.setItemRenderer(new RenderSendaAmigoParamCanjePunto());
        paramCanjePuntoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ParamCanjePunto pa = (ParamCanjePunto) paramCanjePuntoList.getSelected();
                verParamCanjePunto(pa);
            }
        });

        lsParamCanjePunto = new ArrayList<ParamCanjePunto>();

        refreshLista();
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {

        Parada origem = (Parada) (cmbOrigem.getSelectedItem() != null ? cmbOrigem.getSelectedItem().getValue() : null);
        Parada destino = (Parada) (cmbDestino.getSelectedItem() != null ? cmbDestino.getSelectedItem().getValue() : null);

        lsParamCanjePunto.clear();
        lsParamCanjePunto.addAll(paramCanjePuntoService.buscar(origem, destino, fecInicio.getValue(), fecFinal.getValue()));
        paramCanjePuntoList.setData(lsParamCanjePunto);

        if (paramCanjePuntoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaParamCanjePuntoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verParamCanjePunto(new ParamCanjePunto());
    }

    private void verParamCanjePunto(ParamCanjePunto pa) {
        if (pa == null) {
            return;
        }

        Map args = new HashMap();
        args.put("paramCanjePunto", pa);
        args.put("paramCanjePuntoList", paramCanjePuntoList);

        openWindow("/gui/senda_amigo/editarParamCanjePunto.zul",
                Labels.getLabel("editarParamCanjePuntoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ParamCanjePunto> tarifaBusqueda =
                new HibernateSearchObject<ParamCanjePunto>(ParamCanjePunto.class, pagingParamCanjePunto.getPageSize());
        tarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);
        tarifaBusqueda.addSortAsc("feciniciovigencia");
        
        
        plwParamCanjePunto.init(tarifaBusqueda, paramCanjePuntoList, pagingParamCanjePunto);
    }

    

    public Paging getPagingParamCanjePunto() {
        return pagingParamCanjePunto;
    }

    public void setPagingParamCanjePunto(Paging pagingParamCanjePunto) {
        this.pagingParamCanjePunto = pagingParamCanjePunto;
    }

    public Combobox getCmbDestino() {
        return cmbDestino;
    }

    public void setCmbDestino(Combobox cmbDestino) {
        this.cmbDestino = cmbDestino;
    }

    public Combobox getCmbOrigem() {
        return cmbOrigem;
    }

    public void setCmbOrigem(Combobox cmbOrigem) {
        this.cmbOrigem = cmbOrigem;
    }
}
